/*
Programmname:   e-Vertical Kraft Messung                                   
Version:                   3.0 vom 02.05.2018                                            
Beschreibung:         Es wird zunaecht eine Netzwerkverbindung 
                      aufgebaut. Anschließend werden die vom    
                      Sensor erfassten Daten zum Webbrowser    
                      übermittelt
!!Achtung : nicht 100% funktionfähig!!
                                                                                         
                                                                                                             
*/



//Library fuer OLED Display
#include <Wire.h>                 // I2C
#include <Adafruit_GFX.h>         // OLED
#include <Adafruit_SSD1306.h>     // Graphic
#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

#include <WiFi.h>
#include <WiFiClient.h>
#include <ESP32WebServer.h>
#include "SPIFFS.h" // FOR SPIFFS
#include <SD.h>
#include "SDCard.h"
#include "SD.h"
#include "SPI.h" // SPI bus

#include <ctype.h> // for isNumber check
#include <math.h>

//Library fuer waegezellen
#include "cWaage.h"


//****************************************************************************************************************************
typedef struct Timestempel {
  int millisec = 0;
  int seconds = 0;
  int minutes = 0;
  int hours = 0;
  int gesamt = 0;
} Timestempel;
typedef struct Waagedata {
  Timestempel Time;
  float kraft1 = 0;
  float kraft2 = 0;
  float kraft3 = 0;
  float kraft4 = 0;
} Waagedata;
typedef struct charWaagedata {
  char hours[5];
  char minutes[5];
  char seconds[5];
  char millisec[5];
  char kraft1[10];
  char kraft2[10];
  char kraft3[10];
  char kraft4[10];
} charWaagedata;
cWaage Waage1, Waage2, Waage3, Waage4;
Waagedata Daten;
charWaagedata charDaten;
//****************************************************************************************************************************


//const char* ssid     = "ESP32eVert";
//const char* password = "12345678";
const char* ssid     = "HIT-FRITZBOX-7490";
const char* password = "63601430989011937932";

//SPIFFS FILE
const static String fName = "/prop.txt";
const static String dfName = "/data.txt";



int calFac1 = 73;
int calFac2 = 69;
int calFac3 = 69;
int calFac4 = 69;
int dataLines = 0;
int maxFileData = 20;



String webString = "";   // String to display
String webMessage = "";

unsigned long previousMillis = 0;        // will store last temp was read
long interval = 500;   

ESP32WebServer server(80);


//****************************************************************************************************************************
//const char* file = "/Data3/index.txt";
//const char* savefile = "/Data3/save.txt";
#define LOGDATEI "/Log"
const char* dateiName = LOGDATEI "00.csv"; // Z.B. DHT11.csv
File webFile;               // the web page file on the SD card
File dataFile;
//****************************************************************************************************************************


void printDeviceInformation() {
  Serial.println();
  Serial.println("-------------------------------------------------------------------------------------------------" );
  Serial.print("Chip ID: ");
  Serial.println(ESP.getChipRevision());
  Serial.print("Free Heap Size: ");
  Serial.println(ESP.getFreeHeap());
  Serial.print("Chip Size: ");
  Serial.println(ESP.getFlashChipSize());
  Serial.print("Chip Speed: ");
  Serial.print((float)ESP.getFlashChipSpeed() / 1000000);
  Serial.println("Mhz");
  Serial.print("Chip Mode: ");
  Serial.println(ESP.getFlashChipMode());
  Serial.println("-------------------------------------------------------------------------------------------------" );
  Serial.println();
}

void I2CDisplayEinstellung() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);// mit I2C-Adresse 0x3c initialisieren
  display.display();              // Zeigt Adafruit Initialisation Symbol
  delay(2000);                    // 2000ms = 2s
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(INVERSE);
  
}

void AccesPointEinstellung(const char* _ssid, const char* _password) {
  Serial.begin(115200);
  // Connect to WiFi network
  Serial.println();
  WiFi.begin(ssid, password);
  Serial.print("\n\r \n\rWorking to connect");

  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
}

void SPIFFSEinstellung(){  
  SPIFFS.begin();
  delay(10);
  ///////////////////
  // SPIFFS.format(); // uncomment to completely clear data
  File f = SPIFFS.open(fName, "r");
  if (!f) {
    // no file exists so lets format and create a properties file
    Serial.println("Please wait 30 secs for SPIFFS to be formatted");

    SPIFFS.format();

    Serial.println("Spiffs formatted");

    f = SPIFFS.open(fName, FILE_WRITE);
    if (!f) {

      Serial.println("properties file open failed");
    }
    else
    {
      // write the defaults to the properties file
      Serial.println("====== Writing to properties file =========");

      f.print(calFac1); f.print( ","); f.print(calFac2);
      f.print("~"); f.print(calFac3);
      f.print(":"); f.println(calFac4);
      Serial.println("Properties file created");
      dataLines = 1;
      f.close();
    }

  }
  else
  {
    // if the properties file exists on startup,  read it and set the defaults
    Serial.println("Properties file exists. Reading.");

    while (f.available()) {

      //Lets read line by line from the file
      String str = f.readStringUntil('\n');

      String strcalFac1 = str.substring(0, str.indexOf(",")  );
      String strcalFac2 = str.substring(str.indexOf(",") + 1, str.indexOf("~") );
      String strcalFac3 = str.substring(str.indexOf("~") + 1, str.indexOf(":") );
      String strcalFac4 = str.substring(str.indexOf(":") + 1 );

      Serial.println(strcalFac1);
      Serial.println(strcalFac2);
      Serial.println(strcalFac3);
      Serial.println(strcalFac4);

      calFac1 = strcalFac1.toInt();
      calFac2 = strcalFac2.toInt();
      calFac3 = strcalFac3.toInt() ;
      calFac4 = strcalFac4.toInt();
    }

    f.close();
  }
}

void printWifiInfo() {
  byte mac[6];
  Serial.println();
  Serial.println("-------------------------------------------------------------------------------------------------" );
  Serial.print("SSID: ");
  Serial.println(ssid);
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());
  WiFi.macAddress(mac);
  Serial.print("Device MAC Address: ");
  for (int i = 5; i >= 1; i--) {
    Serial.print(mac[i], HEX);
    Serial.print(":");
  }
  Serial.println(mac[0]);
  Serial.print("Signal strength (RSSI): ");
  Serial.print(WiFi.RSSI());
  Serial.println(" dBm");
  Serial.println("-------------------------------------------------------------------------------------------------" );
  Serial.println();
}

void SDKarteEinstellung() {
  // SD Karte Adapter Einstellungen
  Serial.println("Initializing SD card...");
  if (!SD.begin()) {
    Serial.println("ERROR - SD card initialization failed!");
    return;
  }
  uint8_t cardType = SD.cardType();

  if (cardType == CARD_NONE) {
    Serial.println("No SD card attached");
    return;
  }

  Serial.print("SD Card Type: ");
  if (cardType == CARD_MMC) {
    Serial.println("MMC");
  } else if (cardType == CARD_SD) {
    Serial.println("SDSC");
  } else if (cardType == CARD_SDHC) {
    Serial.println("SDHC");
  } else {
    Serial.println("UNKNOWN");
  }

  uint64_t cardSize = SD.cardSize() / (1024 * 1024);
  Serial.printf("SD Card Size: %lluMB\n", cardSize);
  Serial.println("SUCCESS - SD card initialized.");



  Serial.println("-------------------------------------------------------------------------------------------------" );
  Serial.println();
}

//void IndexFilefinden() {
//
//  // check for index.htm file
//  if (!SD.exists(savefile)) {
//    Serial.println("ERROR - Can't find index.txt file!");
//    return;  // can't find index file
//  }
//  Serial.println("SUCCESS - Found index.txt file.");
//  const uint8_t NAMENSLAENGE = sizeof(LOGDATEI) - 1;
//
//
//  //writeFile(SD, savefile, "Hello ");
//  dataFile = SD.open(dateiName, FILE_WRITE);
//  Serial.print("SUCCESS - create "); Serial.println(dateiName);
//}

void HeaderErstellen() {
  File file = SD.open(dateiName, FILE_APPEND);
  if (!file) {
    Serial.println("Failed to open file for appending");
    return;
  }
  else
  {
    file.println(F("Messungen von 1:4 Multikopter"));
    file.print(F("Zeit"));
    file.print(',');
    file.print(F("Kraft1"));
    file.print(',');
    file.print(F("Kraft2"));
    file.print(',');
    file.print(F("Kraft3"));
    file.print(',');
    file.print(F("Kraft4"));
    file.print(',');
    file.println();
    Serial.println("Set-up header");
    file.close();
  }
}

void WaagezelleEinstellung() {
  //Waage_name.initialisierung(int DATA_PIN, float calibrierungsfaktor)
  Waage1.initialisierung(26, 51.04);
  Waage2.initialisierung(25, 51.04);
  Waage3.initialisierung(33, 51.04);
  Waage4.initialisierung(32, 51.04);
}

void Waagekalibrrierungsfunktion() {
  Waage1.kalibrieren();
  Waage2.kalibrieren();
  Waage3.kalibrieren();
  Waage4.kalibrieren();
}

void AnzeigewithDisplayLCD(Waagedata mDaten) {
  //LCD 128x32
  display.clearDisplay();
  display.setCursor(18, 0);
  display.print("--:e-Vertical:--");
  display.setCursor(0, 12); //12
  display.print("W1:\t"); display.print(mDaten.kraft1);
  display.setCursor(0, 24); //24
  display.print("W2:\t"); display.print(mDaten.kraft2);
  display.setCursor(64, 12);  //37
  display.print("W3:\t"); display.print(mDaten.kraft3);
  display.setCursor(64, 24);  //50
  display.print("W4:\t"); display.print(mDaten.kraft4);
  display.display();
  delay(100);                    // 100ms = 0.01s
  }
  
void AnzeigewithSerial(charWaagedata mDaten) {
  
  Serial.print(mDaten.hours);
  Serial.print(":"); Serial.print(mDaten.minutes);
  Serial.print(":"); Serial.print(mDaten.seconds);
  Serial.print(":"); Serial.print(mDaten.millisec);
  Serial.print(","); Serial.print(mDaten.kraft1);
  Serial.print(","); Serial.print(mDaten.kraft2);
  Serial.print(","); Serial.print(mDaten.kraft3);
  Serial.print(","); Serial.println(mDaten.kraft4);
}

void AnzeigeinSDKartespeichern(charWaagedata mDaten) {
  File file = SD.open(dateiName, FILE_APPEND);
  if (!file) {
    Serial.println("Failed to open file for appending");
    return;
  }
  file.print(mDaten.hours); file.print(":"); 
  file.print(mDaten.minutes);file.print(":");
  file.print(mDaten.seconds);file.print(":");
  file.print(mDaten.millisec); 
  file.print(","); file.print(mDaten.kraft1);
  file.print(","); file.print(mDaten.kraft2);
  file.print(","); file.print(mDaten.kraft3);
  file.print(","); file.print(mDaten.kraft4);file.print("\n");
  file.close();
}

Timestempel MilliInSecondandMinutes(int m_millis) {
  Timestempel Ruckgabe;
  Ruckgabe.gesamt = m_millis;
  Ruckgabe.millisec = m_millis % 1000;
  Ruckgabe.seconds = (m_millis / 1000) % 60;
  Ruckgabe.minutes = ((m_millis / (1000 * 60)) % 60);
  Ruckgabe.hours = ((m_millis / (1000 * 60 * 60)) % 24);
  return Ruckgabe;
}
char * floatToChar(char * outstr, float value, int places, int minwidth = 0, bool rightjustify = false) {
  int digit;
  float tens = 0.1;
  int tenscount = 0;
  int i;
  float tempfloat = value;
  int c = 0;
  int charcount = 1;
  int extra = 0;
  // make sure we round properly. this could use pow from <math.h>, but doesn't seem worth the import
  // if this rounding step isn't here, the value  54.321 prints as 54.3209

  // calculate rounding term d:   0.5/pow(10,places)
  float d = 0.5;
  if (value < 0)
    d *= -1.0;
  // divide by ten for each decimal place
  for (i = 0; i < places; i++)
    d /= 10.0;
  // this small addition, combined with truncation will round our values properly
  tempfloat +=  d;

  // first get value tens to be the large power of ten less than value
  if (value < 0)
    tempfloat *= -1.0;
  while ((tens * 10.0) <= tempfloat) {
    tens *= 10.0;
    tenscount += 1;
  }

  if (tenscount > 0)
    charcount += tenscount;
  else
    charcount += 1;

  if (value < 0)
    charcount += 1;
  charcount += 1 + places;

  minwidth += 1; // both count the null final character
  if (minwidth > charcount) {
    extra = minwidth - charcount;
    charcount = minwidth;
  }

  if (extra > 0 and rightjustify) {
    for (int i = 0; i < extra; i++) {
      outstr[c++] = ' ';
    }
  }

  // write out the negative if needed
  if (value < 0)
    outstr[c++] = '-';

  if (tenscount == 0)
    outstr[c++] = '0';

  for (i = 0; i < tenscount; i++) {
    digit = (int) (tempfloat / tens);
    itoa(digit, &outstr[c++], 10);
    tempfloat = tempfloat - ((float)digit * tens);
    tens /= 10.0;
  }

  // if no places after decimal, stop now and return

  // otherwise, write the point and continue on
  if (places > 0)
    outstr[c++] = '.';


  // now write out each decimal place by shifting digits one by one into the ones place and writing the truncated value
  for (i = 0; i < places; i++) {
    tempfloat *= 10.0;
    digit = (int) tempfloat;
    itoa(digit, &outstr[c++], 10);
    // once written, subtract off that digit
    tempfloat = tempfloat - (float) digit;
  }
  if (extra > 0 and not rightjustify) {
    for (int i = 0; i < extra; i++) {
      outstr[c++] = ' ';
    }
  }


  outstr[c++] = '\0';
  return outstr;
}
charWaagedata WaagedataincharConverter(Waagedata mData) {
  charWaagedata lokalcharData;
  /*String sgesamt = String(mData.Time.gesamt);
  sgesamt.toCharArray(lokalcharData.gesamt,2);*/
  itoa(mData.Time.hours,lokalcharData.hours,10);
  itoa(mData.Time.minutes,lokalcharData.minutes,10);
  itoa(mData.Time.seconds,lokalcharData.seconds,10);
  itoa(mData.Time.millisec,lokalcharData.millisec,10);
  //lokalcharData.gesamt= (char)mData.Time.gesamt;
  floatToChar(lokalcharData.kraft1, mData.kraft1, 3);
  floatToChar(lokalcharData.kraft2, mData.kraft2, 3);
  floatToChar(lokalcharData.kraft3, mData.kraft3, 3);
  floatToChar(lokalcharData.kraft4, mData.kraft4, 3);

  return lokalcharData;
}
void StrClear(char *str, char length) { // sets every element of str to 0 (clears array)
  for (int i = 0; i < length; i++) {
    str[i] = 0;
  }
}
char StrContains(char *str, char *sfind) { // searches for the string sfind in the string str
  // returns 1 if string found
  // returns 0 if string not found
  char found = 0;
  char index = 0;
  char len;

  len = strlen(str);

  if (strlen(sfind) > len) {
    return 0;
  }
  while (index < len) {
    if (str[index] == sfind[found]) {
      found++;
      if (strlen(sfind) == found) {
        return 1;
      }
    }
    else {
      found = 0;
    }
    index++;
  }
  return 0;
}
void ADCinSleepMode() {
  Waage1.power_down();
  Waage2.power_down();
  Waage3.power_down();
  Waage4.power_down();
  delay(100);
  Waage1.power_up();
  Waage2.power_up();
  Waage3.power_up();
  Waage4.power_up();
}
  
/////////////////////////////////////////////////
void clearDataFile() // deletes all the stored data
{
  
  if (!SPIFFS.remove(dfName)) {
    Serial.println("data file open to clear failed");
  }
  else
  {
    Serial.println("-- Data file cleared =========");
    
  }
   File temp = SPIFFS.open(dfName, FILE_WRITE);

}

///////////////////////////////////////////////////////////////////////////////////
// removes the first line of a file by writing all data except the first line
// to a new file. The old file is deleted and new file is renamed.
///////////////////////////////////////////////////////////////////////////////////
void removeFileLine(String fi)
{
  File original = SPIFFS.open(fi,"r");
  if (!original) {

    Serial.println("original data file open failed");
  }

  File temp = SPIFFS.open("/tempfile.txt", FILE_WRITE);
  if (!temp) {

    Serial.println("temp data file open failed");
  }

  Serial.println("------ Removing Data Lines ------");

  //Lets read line by line from the file
  for (int i = 0; i < maxFileData; i++) {

    String str = original.readStringUntil('\n'); // read a line
    if (i > 0) { // skip writing first line to the temp file

      temp.println(str);
      //  Serial.println(str); // uncomment to view the file data in the serial console
    }
  }

  int origSize = original.size();
  int tempSize = temp.size();
  temp.close();
  original.close();

  Serial.print("size orig: "); Serial.print(origSize); Serial.println(" bytes");
  Serial.print("size temp: "); Serial.print(tempSize); Serial.println(" bytes");

  if (! SPIFFS.remove(dfName))
    Serial.println("Remove file failed");


  if (! SPIFFS.rename("/tempfile.txt", dfName))
    Serial.println("Rename file failed");
  // dataLines--;
}

//////////////////////////////////////////////////////////////////////
// writes the most recent variable values to the data file          //
//////////////////////////////////////////////////////////////////////
void updateDataFile(charWaagedata mDaten)
{
  Serial.println("dataLines: ");
  Serial.println(dataLines);
  if (dataLines >= maxFileData)
  {
    removeFileLine(dfName);
  }
  ///////
  File f = SPIFFS.open(dfName, FILE_APPEND);
  if (!f) {

    Serial.println("data file open failed");
  }
  else
  {
    Serial.println("====== Writing to data file =========");

   f.print(mDaten.hours); f.print("h"); 
   f.print(mDaten.minutes);f.print("m");
   f.print(mDaten.seconds);f.print("s");
   f.print(mDaten.millisec);f.print(":");
    f.print(Waage1.getGewicht()); f.print( ","); f.println(Waage2.getGewicht());
    f.print( ","); f.println(Waage3.getGewicht()); f.print( ","); f.println(Waage4.getGewicht());



    Serial.println("Data file updated");
    f.close();
  }

  Serial.print("millis: ");
  Serial.println(millis());

}

//////////////////////////////////////////////////////////////////////////////
// reads the data and formats it so that it can be used by google charts    //
//////////////////////////////////////////////////////////////////////////////

String readDataFile()
{
  String returnStr = "";
  File f = SPIFFS.open(dfName,"r");

  if (!f)
  {
    Serial.println("Data File Open for read failed.");

  }
  else
  {
    Serial.println("----Reading Data File-----");
    dataLines = 0;

    while (f.available()) {

      //Lets read line by line from the file
      dataLines++;
      String str = f.readStringUntil('\n');
      String switchState =  str.substring(0, str.indexOf(":")  );
      /*
          String tempF = str.substring(str.indexOf(":") + 1, str.indexOf(",")  );
        //  String humid = str.substring(str.indexOf(",") + 1 );
        //    String milliSecs = str.substring(str.indexOf("~") + 1 , str.indexOf("~"));
        //   Serial.println(tempF);
        //   Serial.println(humid);
        //  Serial.println(str);
      */

      returnStr += ",['" + switchState + "'," + str.substring(str.indexOf(":") + 1)+ "]";
    }
    f.close();
  }

  return returnStr;

}

////////////////////////////////////////////////////////////////////////////////////
//      creates the HTML string to be sent to the client                          //
////////////////////////////////////////////////////////////////////////////////////

void setHTML()
{
  webString = "<html><head>\n";
  webString += "<meta http-equiv=\"refresh\" content=\"3;url=http://" + WiFi.localIP().toString() + "\"> \n";

  ///////////// google charts script
  webString += "<script type=\"text/javascript\" src=\"https://www.gstatic.com/charts/loader.js\"></script> \n";
  webString += "   <script type=\"text/javascript\"> \n";
  webString += "    google.charts.load('current', {'packages':['corechart','gauge']}); \n";
  
  webString += "    google.charts.setOnLoadCallback(drawTempChart); \n";
  webString += "    google.charts.setOnLoadCallback(drawHumidChart); \n";
  webString += "    google.charts.setOnLoadCallback(drawHumidChart1); \n";
  webString += "    google.charts.setOnLoadCallback(drawHumidChart2); \n";
  webString += "    google.charts.load('current', {'packages':['corechart','line']}); \n";
  webString += "    google.charts.setOnLoadCallback(drawChart); \n ";

  // draw temp guage
  webString += "   function drawTempChart() { \n";
  webString += "      var data = google.visualization.arrayToDataTable([ \n";
  webString += "        ['Label', 'Value'], ";
  webString += "        ['Temp\xB0',  ";
  webString += Waage1.getGewicht();
  webString += " ], ";
  webString += "       ]); \n";
  // setup the google chart options here
  webString += "    var options = {";
  webString += "      width: 250, height: 150,";
  webString += "      min: 0, max: 120,";
  webString += "      greenFrom: -10, greenTo: 80,";
  webString += "      yellowFrom:  80, yellowTo: 100,";
  webString += "      redFrom: 100, redTo: 120,";
  webString += "       minorTicks: 5";
  webString += "    }; \n";
  webString += "   var chart = new google.visualization.Gauge(document.getElementById('chart_divTemp')); \n";
  webString += "  chart.draw(data, options); \n";
  webString += "  } \n";

  // draw humidity guage
  webString += "   function drawHumidChart() { \n";
  webString += "      var data = google.visualization.arrayToDataTable([ \n";
  webString += "        ['Label', 'Value'], ";
  webString += "        ['Humidity',  ";
  webString += Waage2.getGewicht();
  webString += " ], ";
  webString += "       ]); \n";
  // setup the google chart options here
  webString += "    var options = {";
  webString += "      width: 250, height: 150,";
  webString += "      min: 0, max: 120,";
  webString += "      greenFrom: 0, greenTo: 25,";
  webString += "      yellowFrom: 25, yellowTo: 75,";
  webString += "      redFrom: 75, redTo: 120,";
  webString += "       minorTicks: 5";
  webString += "    }; \n";
  webString += "   var chart = new google.visualization.Gauge(document.getElementById('chart_divHumid')); \n";
  webString += "  chart.draw(data, options); \n";
  webString += "  } \n";
  
// draw humidity guage
  webString += "   function drawHumidChart1() { \n";
  webString += "      var data = google.visualization.arrayToDataTable([ \n";
  webString += "        ['Label', 'Value'], ";
  webString += "        ['Humidity',  ";
  webString += Waage3.getGewicht();
  webString += " ], ";
  webString += "       ]); \n";
  // setup the google chart options here
  webString += "    var options = {";
  webString += "      width: 250, height: 150,";
  webString += "      min: 0, max: 120,";
  webString += "      greenFrom: 0, greenTo: 25,";
  webString += "      yellowFrom: 25, yellowTo: 75,";
  webString += "      redFrom: 75, redTo: 120,";
  webString += "       minorTicks: 5";
  webString += "    }; \n";
  webString += "   var chart = new google.visualization.Gauge(document.getElementById('chart_divHumid')); \n";
  webString += "  chart.draw(data, options); \n";
  webString += "  } \n";

  // draw humidity guage
  webString += "   function drawHumidChart2() { \n";
  webString += "      var data = google.visualization.arrayToDataTable([ \n";
  webString += "        ['Label', 'Value'], ";
  webString += "        ['Humidity',  ";
  webString += Waage4.getGewicht();
  webString += " ], ";
  webString += "       ]); \n";
  // setup the google chart options here
  webString += "    var options = {";
  webString += "      width: 250, height: 150,";
  webString += "      min: 0, max: 120,";
  webString += "      greenFrom: 0, greenTo: 25,";
  webString += "      yellowFrom: 25, yellowTo: 75,";
  webString += "      redFrom: 75, redTo: 120,";
  webString += "       minorTicks: 5";
  webString += "    }; \n";
  webString += "   var chart = new google.visualization.Gauge(document.getElementById('chart_divHumid')); \n";
  webString += "  chart.draw(data, options); \n";
  webString += "  } \n";

  // draw main graph
  webString += "    function drawChart() { \n";

  webString += "     var data = google.visualization.arrayToDataTable([ \n";
  webString += "       ['Hit', 'Waage 1', 'Waage 2', 'Waage 4', 'Waage 4'] ";


  webString += readDataFile();
  // open file for reading

  webString += "     ]); \n";
  webString += "     var options = { \n";
  webString += "        title: 'Sensor Activity', ";
//  webString += "        curveType: 'function', \n";

//  webString += "  series: { \n";
//  webString += "         0: {targetAxisIndex: 0}, \n";
//  webString += "         1: {targetAxisIndex: 1} \n";
//  webString += "       }, \n";

//  webString += "  vAxis: { \n";
//  webString += "         // Adds titles to each axis. \n";
//  webString += "         0: {title: 'Newton (N)'}, \n";
//  webString += "         1: {title: ''} \n";
//  webString += "       }, \n";
//
//  webString += "  hAxis: { \n";
//  webString += "         // Adds titles to each axis. \n";
//  webString += "         0: {title: 'Time (milisecond)'}, \n";
//  webString += "         1: {title: ''} \n";
//  webString += "       }, \n";
  
  webString += "  vAxis: { \n";
  webString += "         // Adds titles to each axis. \n";
  webString += "         title: 'Newton (N)' \n";
//  webString += "         title: '' \n";
  webString += "       }, \n";

  webString += "  hAxis: { \n";
  webString += "         // Adds titles to each axis. \n";
  webString += "        title: 'Time (milisecond)' \n";
//  webString += "         1: {title: ''} \n";
  webString += "       }, \n";

  webString += "         legend: { position: 'bottom' } \n";
  webString += "       }; \n";

  webString += "       var chart = new google.visualization.LineChart(document.getElementById('curve_chart')); \n";

  webString += "       chart.draw(data, options); \n";
  webString += "      } \n";

  ////////////
  webString += "    </script> \n";
  webString += "</head><body>\n";
  webString += "<form action=\"http://" + WiFi.localIP().toString() + "/submit\" method=\"POST\">";
  webString += "<h1>ESP8266-12E DHT Thermostat IoT</h1>\n";
  webString += "<div style=\"color:red\">" + webMessage + "</div>\n";

  webString += "<table style=\"width:800px;\"><tr><td>";
  webString += "<div>Kalibrierungsfaktor W1: &le; " + String((int)calFac1) + "&deg; F</div>\n";
  webString += "<div>Kalibrierungsfaktor W2: &ge; " + String((int)calFac2) + "&deg; F</div>\n";
  webString += "</td><td style=\"text-align:right\">";
  webString += "Waage 1: &le; <input type='text' value='" + String((int)calFac1) + "' name='calFac1' maxlength='3' size='2'><br>\n";
  webString += "Waage 2: &ge; <input type='text' value='" + String((int)calFac2) + "' name='calFac2' maxlength='3' size='2'><br>\n";
  webString += "</td><td style=\"text-align:right\">";
  webString += "Waage 3: <input type='text' value='" + String((long)calFac3 ) + "' name='calFac3' maxlength='3' size='2'><br>\n";
  webString += "Waage 4: <input type='text' value='" + String((long)calFac4) + "' name='calFac4' maxlength='3' size='2'><br>\n";

  webString += "</td><td>";
  webString += "<input type='submit' value='Submit' >";
  webString += "</td></tr></table>\n";

  webString += "<table style=\"width:800px;\"><tr><td>";
  webString += "<div style=\"width:300px\"><b>Last Readings</b></div>\n";
  webString += "<div>Kalibrierungsfaktor W3: " + String((int)calFac3 ) + "&deg; F</div>\n";
  webString += "<div>Kalibrierungsfaktor W4: " + String((int)calFac4) + "%</div> \n";

//  if (digitalRead(RELAYPIN) == LOW)
//    webString += "<div>Heat is OFF</div>";
//  else
//    webString += "<div>Heat is ON</div>";

  webString += "<div>Data Lines: " + String((int)dataLines) + "</div> \n";
  //  webString += "<div>Total On Time: " + String( ((onCount * interval) / 1000) / 60 ) + " minutes</div> \n";
  webString += "<div>Sample Rate: " + String(interval) + " mili</div> \n";

  webString += "<div><a href=\"http://" + WiFi.localIP().toString() + "\">Refresh</a></div>\n";
  webString += "</td><td>";
  webString += "<div id=\"chart_divTemp\" style=\"width: 250px;\"></div>\n";
  webString += "</td><td>";
  webString += "<div id=\"chart_divHumid\" style=\"width: 250px;\"></div>\n";
  webString += "</td></tr></table>\n";
  webString += "<div id=\"curve_chart\" style=\"width: 1800px; height: 500px\"></div> \n";
  webString += "<div><a href=\"/clear\">Clear Data</a></div> \n";

  webString += "</body></html>\n";
}

//////////////////////////////////
///  used for error checking   ///
//////////////////////////////////

boolean isValidNumber(String str) {
  for (byte i = 0; i < str.length(); i++)
  {
    if (isDigit(str.charAt(i))) return true;
  }
  return false;
}

////////////////////////////////////////////////////////////////////
// handler for web server request: http://IpAddress/submit        //
////////////////////////////////////////////////////////////////////

void handle_submit() {

  webMessage = "";
  

  if (server.args() > 0 ) {
    for ( uint8_t i = 0; i < server.args(); i++ ) {

      if (server.argName(i) == "calFac1") {

        if (server.arg(i) != "")
        {
          if (isValidNumber(server.arg(i)) )
            calFac1 = server.arg(i).toInt();
//          else
//            webMessage += "Heat On must be a number<br>";
        }
//        else
//          webMessage += "Heat On is required<br>";
      }

      if (server.argName(i) == "calFac2") {

        if (server.arg(i) != "")
        {
          if (isValidNumber(server.arg(i)) )
            calFac2 = server.arg(i).toInt();
//          else
//            webMessage += "Heat Off must be a number<br>";

        }
//        else
//          webMessage += "Heat Off is required<br>";
      }


      if (server.argName(i) == "calFac3") {

        if (server.arg(i) != "")
        {
          if (isValidNumber(server.arg(i)) )
            calFac3 = server.arg(i).toInt();
//          else
//            webMessage += "Sample Rate must be a number<br>";
        }
//        else
//          webMessage += "Sample Rate is required<br>";
      }

      if (server.argName(i) == "calFac4") {

        if (server.arg(i) != "")
        {
          if (isValidNumber(server.arg(i)) )
            calFac4 = server.arg(i).toInt();
//          else
//            webMessage += "Max Chart Data must be a number<br>";
        }
//        else
//          webMessage += "Max Chart Data is required<br>";
      }

    }

//    if (tempOFF <= kalibrationFaktor)
//      webMessage += "Heat On must be lower than Heat Off<br>";
//
//    if (sRate < 1)
//      webMessage += "Sample Rate must be greater than or equal to 10<br>";
//
//    if (maxData < 10 || maxData > 300)
//      webMessage += "Max Chart Data must be between 10 and 300<br>";

    if (webMessage == "")
    {
//      calFac1 = kalibrationFaktor;
//      heatOff = tempOFF;
//      interval = sRate;
//      maxFileData = maxData;
      ///////
      File f = SPIFFS.open(fName, "w");
      if (!f) {

        Serial.println("file open for properties failed");
      }
      else
      {
        Serial.println("====== Writing to config file =========");

        f.print(calFac1); f.print( ","); f.print(calFac2);
        f.print("~"); f.print(calFac3);
        f.print(":"); f.println(calFac4);
        Serial.println("Properties file updated");
        f.close();
      }

    }
  }


  if (webMessage == "") {
    webMessage = "Settings Updated";
  }


//  gettemperature();

  setHTML();
  server.send(200, "text/html", webString);            // send to someones browser when asked

  delay(100);
}


////////////////////////////////////////////////////////////
// handler for web server request: http://IpAddress/      //
////////////////////////////////////////////////////////////

void handle_root() {

//  gettemperature();       // read sensor
  webMessage = "";
  setHTML();
  server.send(200, "text/html", webString);            // send to someones browser when asked

  delay(100);
}


void setup() {
  //rtc_clk_cpu_freq_set(RTC_CPU_FREQ_80M);
  printDeviceInformation();
  AccesPointEinstellung(ssid, password);
  I2CDisplayEinstellung();
  printWifiInfo();
  SDKarteEinstellung();
//  IndexFilefinden();
  WaagezelleEinstellung();
  HeaderErstellen();
  SPIFFSEinstellung();
  //Waagekalibrrierungsfunktion()  // uncommentieren wenn kalibrieren wollen.

  Daten.Time = MilliInSecondandMinutes(millis());
  readDataFile();
  // now read the DHT and set the temp and humidity variables
  // update the datafile to start a new session
  updateDataFile(WaagedataincharConverter(Daten));
  
  // web client handlers
  server.on("/", handle_root);

  server.on("/submit", handle_submit);

  server.on("/clear", []() {
    // handler for http://iPaddress/clear

    // deletes all the stored data for temp and humidity
    clearDataFile();

    webMessage = "Data Cleared";

    // read the DHT and use new values to start new file data
//    gettemperature();
    updateDataFile(WaagedataincharConverter(Daten));
    setHTML(); // this will set the webString varialbe with HTML
    server.send(200, "text/html", webString);            // send to someones browser when asked
    delay(100);

  });
  server.begin();
  Serial.println("HTTP server started");
}


void loop() {
  
  Daten.Time = MilliInSecondandMinutes(millis());
  Daten.kraft1 = Waage1.getGewicht();
  Daten.kraft2 = Waage2.getGewicht();
  Daten.kraft3 = Waage3.getGewicht();
  Daten.kraft4 = Waage4.getGewicht();
  ADCinSleepMode();
  AnzeigewithSerial(WaagedataincharConverter(Daten));
  AnzeigeinSDKartespeichern(WaagedataincharConverter(Daten));
  AnzeigewithDisplayLCD(Daten);
  
  unsigned long currentMillis = millis();
  // cast to unsigned long to handle rollover
  if ((unsigned long)(currentMillis - previousMillis) >= interval )
  {
    // save the last time you read the sensor
    previousMillis = currentMillis;

    Serial.print("Temp: ");
    Serial.println(Waage1.getGewicht());
    Serial.print("Humidity: ");
    Serial.println(Waage2.getGewicht());

    updateDataFile(WaagedataincharConverter(Daten));
    readDataFile();
    setHTML(); // this will set the webString varialbe with HTML
    server.send(200, "text/html", webString);            // send to someones browser when asked
  }
  
server.handleClient();
delay(100);
}
